import { types as t } from '@babel/core';
import { Cache, LoadModule, Options, ValueFactory } from './types';
/**
 * @internal
 */
export declare function formatError(message: string, path: string, source: string): string;
/**
 * @internal
 */
export declare function formatErrorLineColumn(message: string, path: string, source: string, line?: number, column?: number): string;
/**
 * @internal
 */
export declare function formatErrorStartEnd(message: string, path: string, source: string, start: number, end?: number): string;
/**
 * @internal
 */
export declare function hash(...valueList: string[]): string;
/**
 * Simple cache helper
 * preventCache usage: non-fatal error
 * @internal
 */
export declare function withCache(cacheInstance: Cache, key: string[], valueFactory: ValueFactory): Promise<any>;
/**
 * @internal
 */
export declare function interopRequireDefault(obj: any): any;
/**
 * import is a reserved keyword, then rename
 * @internal
 */
export declare function renameDynamicImport(fileAst: t.File): void;
/**
 * @internal
 */
export declare function parseDeps(fileAst: t.File): string[];
/**
 * @internal
 */
export declare function transformJSCode(source: string, moduleSourceType: boolean, filename: string, options: Options): Promise<(string | string[])[]>;
/**
 * Create a cjs module
 * @internal
 */
export declare function createModule(filename: string, source: string, options: Options, loadModule: LoadModule): {
    exports: {};
};
/**
 * @internal
 */
export declare function createJSModule(source: string, moduleSourceType: boolean, filename: string, options: Options, loadModule: LoadModule): Promise<{}>;
/**
 * Just load and cache given dependencies.
 * @internal
 */
export declare function loadDeps(filename: string, deps: string[], options: Options, loadModule: LoadModule): Promise<void>;
